////////////////////////////////////////////////////////////////////////////////
//
//	This is code for the Singapore Traffic Gadget prototype
//
////////////////////////////////////////////////////////////////////////////////

var g_viewElements				= null;

var g_dataStale			= true;
var g_freshDataAvailable	= false;		
var g_refreshing		= false;		
var g_rawRoadData			= "unavailable";

var camNo_url = -1;
var g_RoadSourceUrl;
var cameraPicURL;
////////////////////////////////////////////////////////////////////////////////
//
// GADGET Related
//
////////////////////////////////////////////////////////////////////////////////

System.Gadget.settingsUI    	= "settings.html";


function viewElementsObject()
{
	this.regionArea		= document.getElementById("regionArea");
	//this.regionArea1	= document.getElementById("regionArea1");
	this.regionLocation = document.getElementById("regionLocation");
	this.regionTime     = document.getElementById("regionTime");
	//this.excatCamera	= document.getElementById("excatCamera");
	
}//regionArea1
////////////////////////////////////////////////////////////////////////////////////

function loadUp()
{   
    var refreshLink = document.getElementById("refreshLink");

    if(refreshLink != null)
    {
        document.getElementById("refreshLink").style.visibility = "hidden";
    }
  
    g_viewElements = new viewElementsObject();
    System.Gadget.onUndock = checkState;
    System.Gadget.onDock = checkState;
    checkState();
}
////////////////////////////////////////////////////////////////////////////////////
function startTimer(camNo)
{

    	g_viewElements = new viewElementsObject();
	camNo_url = camNo;
	if(camNo!=null)
	{
	    System.Gadget.Settings.write("camNoRecent", camNo);
	    System.Gadget.Settings.write("camNo",camNo_url);
	    g_RoadSourceUrl	= "http://www.onemotoring.com.sg/trafficsmart/images/"+camNo_url+".html";
	    //document.write(g_RoadSourceUrl);
	    refreshRoadData();
	    window.clearInterval(g_Timer);
	    g_timer = window.setInterval("refreshRoadData()",600000);//must change method name   
	}
}

///////////////////////////////////////////////////////////////////////////////////

function viewCam()
{
    var url = System.Gadget.Settings.read("lastURL");
    if(url != null && url != "")
    {
        System.Gadget.Settings.write("fromViewCam",true);
        document.location.href = url
    }   
}

////////////////////////////////////////////////////////////////////////////////////
function checkToLoadPhoto()
{
    var fromViewCam = System.Gadget.Settings.read("fromViewCam");
    if(fromViewCam != null && fromViewCam != "")
    {
        if(fromViewCam == true)
        {
            System.Gadget.Settings.write("fromViewCam",false);
            var camNo = System.Gadget.Settings.read("camNoRecent");
            if(camNo != null && camNo != "")
            {
                if(document.getElementById("refreshLink") != null)
                {
                    document.getElementById("refreshLink").style.visibility = "visible";
                }            
                startTimer(camNo);
            }       
        }
    } 
}

////////////////////////////////////////////////////////////////////////////////////
function refreshRoadData() //refreshWeatherData and associated methods
{
	req = false;

	req = new ActiveXObject("Microsoft.XMLHTTP");

	if(req) 
	{
		
		g_refreshing = true;
		
		// We are going to do an async pull of data
		// Telling the req object to call 'processReqChange' whenever
		// the state of the req object changes
		req.onreadystatechange = processReqChange;
				
		// Here we go...
		req.open("GET", g_RoadSourceUrl, true);
		req.send("");
		
	}
}
////////////////////////////////////////////////////////////////////////////////////
function processReqChange() 
{
    // only if req shows "loaded"

    if (req.readyState == 4) 
    {
        
	// only if "OK"
        if (req.status == 200) 
        {
         
	    g_dataStale				= false;
            g_freshDataAvailable 	= true;
            g_refreshing 			= false;
            g_rawRoadData 		= req.responseText;

		 tickTock();
        } 
        else 
        {

		g_dataStale				= true;
        	g_freshDataAvailable 	= false;
        	g_refreshing			= false;
        	g_rawRoadData		= "unavailable";  
		refreshRoadData();
        }
	
    }
}

/////////////////////////////////////////////////////////////////////////////////
//var cameraURL = "";
var g_oldImage;
var g_oldMap;
//var global_url;
function tickTock()// This method is called everytime a 'tick' activity occurs
{	
		//refreshWeatherData();
		//alert();
		//alert(1);
		var myregexp = /http.*jpg/;
		var myregexp2 = /View from.*br>/;
		var myregexp3 = /Time:.*span>/;
		
		var match = null;
		var match2 = null;
		var match3 = null;
		
		var moreToProcess 	= true;

		while(moreToProcess && g_rawRoadData!=null)
		{
		    match3 = myregexp3.exec(g_rawRoadData);
		    match2 = myregexp2.exec(g_rawRoadData);
			match  = myregexp.exec(g_rawRoadData);
			if(match[0] != null)
			{
			    moreToProcess=false;
			}	
		}
		//document.write(match[0]);
		var g_url = match[0];
		var location = match2[0];
		var time = match3[0];
	
		location = location.substring(9);
		
		g_oldImage = g_viewElements.regionArea.src;
		g_oldMap = g_viewElements.regionArea.useMap;

		g_viewElements.regionArea.src=g_url;
		g_viewElements.regionArea.useMap="#";
		g_viewElements.regionLocation.innerHTML = location;
		g_viewElements.regionTime.innerHTML = time;	
		
		System.Gadget.Settings.write("cameraURL", g_url);
		System.Gadget.Settings.write("mapToUse", "#");
		System.Gadget.Settings.write("location", location);
		System.Gadget.Settings.write("time", time);
}
////////////////////////////////////////////////////////////////////////////////////
function chooseMap()
{
	//if (g_oldImage!=null && g_oldMap !=null)
	//{
	//    g_viewElements.regionArea.src = g_oldImage;
	//    g_viewElements.regionArea.useMap = g_oldMap;
	//}
	var url = System.Gadget.Settings.read("lastMap");
	if(url != "" && url != null)
	{
	    document.location.href = url;
	} 
	else
	{
	    document.location.href = "RoadImage.html";
	}
}
////////////////////////////////////////////////////////////////////////////////////
function saveLastMap(url)
{
    if(url != "" && url != null)
    {
        System.Gadget.Settings.write("lastMap",url);
    }
    else
    {
        System.Gadget.Settings.write("lastMap","RoadImage.html");
    }
}

////////////////////////////////////////////////////////////////////////////////////
function updateLastUpdatedValue()
{
	var currentTime = new Date();
	var theday   	= currentTime.getDay();
	var thedayword 	= "";
	var themonth 	= currentTime.getMonth()+1;
	var thetoday 	= currentTime.getDate();
	var thehour 	= currentTime.getHours();
	var themin		= currentTime.getMinutes();
	var thesec		= currentTime.getSeconds();
	
	switch (theday) 
	{
	   case 1:
	      thedayword = "Mon";
	      break;
	   case 2:
	      thedayword = "Tue";
	      break;
	   case 3:
	      thedayword = "Wed";
	      break;
	   case 4:
	      thedayword = "Thr";
	      break;
	   case 5:
	      thedayword = "Fri";
	      break;
	   case 6:
	      thedayword = "Sat";
	      break;
	   case 7:
	      thedayword = "Sun";
	      break;
	   default:
	      thedaywork = "Huh?";
	}
	
    g_viewElements.footerText.innerText = thedayword + " " + themonth + "/" + thetoday + " " + thehour + ":" + themin;
 
}
////////////////////////////////////////////////////////////////////////////////////
function dockedState()
{
    with(document.body.style)
            width=405,height=317;
    //System.Gadget.background="url(bgsmall.png)";
    //System.Gadget.bgcolor="black";            

    //g_viewElements.regionArea.style.width = "200px";
    //g_viewElements.regionArea.style.height = "144px";

    //g_viewElements.regionArea1.width = "200px";
    //g_viewElements.regionArea1.style.height = "144px";
    
    g_viewElements.regionArea.style.width = "385px";
    g_viewElements.regionArea.style.height = "240px";

    //g_viewElements.regionArea1.width = "385px";
    //g_viewElements.regionArea1.style.height = "240px";    


}
//////////////////////////////////////////////////////////////////////
function undockedState()
{
    with(document.body.style)
        width=405,height=317;
        
    //System.Gadget.background="url(bglarge.png)";
    //System.Gadget.bgcolor="black"; 
            
    
    if(g_viewElements.regionArea.src != "../image/singapore_main.gif")

    {

	g_viewElements.regionArea.style.height = "240px";
	g_viewElements.regionArea.style.width = "385px";
    }
    else
    {
	g_viewElements.regionArea.style.height = "229px";
	g_viewElements.regionArea.style.width = "370px";
    }

//    g_viewElements.regionArea1.style.width = "385px";	
//    g_viewElements.regionArea1.style.height = "240px";
}
//////////////////////////////////////////////////////////////////////
function checkState()
{
    if(!System.Gadget.docked)
    {
        undockedState();
    }
    else if (System.Gadget.docked)
    {
        dockedState();
    }
}
//////////////////////////////////////////////////////////////////////

function closeFlyout()
{
    System.Gadget.Flyout.show = false;
}

//////////////////////////////////////////////////////////////////////

function saveLastURL(url, roadCode)
{
    if(document.getElementById("refreshLink") != null)
    {
        document.getElementById("refreshLink").style.visibility = "visible";
    }
    System.Gadget.Settings.write("lastURL", url);
    System.Gadget.Settings.write("roadCode", roadCode);
}

//////////////////////////////////////////////////////////////////////

function checkConnection() 
{
    var xmlObj = null;
    var url = "http://www.onemotoring.com.sg";
    try
    {
        xmlObj = new ActiveXObject("Microsoft.XMLHTTP");
        xmlObj.open("GET", url, true);
        xmlObj.send("");
        xmlObj.onreadystatechange = function() {
        if (xmlObj.readyState == 4)
        { 
            if (xmlObj.status == 200) 
            { 
                var rssXML = xmlObj.responseXML; 
            }
            else
            {
                document.getElementById("initText").innerHTML = "<span>Service unavailable</span>";
            }
        } 
        else 
        {
        }        
        xmlObj.send(null);
        }
    }
    catch(err)
    {
        document.getElementById("initText").innerHTML = "<span>Service unavailable</span>";
    }
    
    System.Gadget.Settings.write("connectionAvailable",true);
    window.setTimeout("checkConnection()",600000);
}

/////////////////////////////////////////////////////////////////////